package com.steerinfo.meterwork.meterworkrailwayrecmain.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.dto.CommonCombination;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkrailwaymotorialreceived.model.MeterWorkRailwayMotorialReceived;
import com.steerinfo.meterwork.meterworkrailwayreceived.model.MeterWorkRailwayReceived;
import com.steerinfo.meterwork.meterworkrailwayrecmain.model.MeterWorkRailwayRecMain;
import com.steerinfo.meterwork.meterworkrailwayrecmain.model.newCls;
import com.steerinfo.meterwork.meterworkrailwayrecmain.service.IMeterWorkRailwayRecMainService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.ArrayList;
import java.math.BigDecimal;

/**
 * MeterWorkRailwayRecMain RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-02-21 03:42
 * 类描述
 * 修订历史：
 * 日期：2022-02-21
 * 作者：generator
 * 参考：
 * 描述：MeterWorkRailwayRecMain RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/meterworkrailwayrecmains")
@Api(value = "/${api.version}/meterworkrailwayrecmains", tags = "车次号查询 - MeterWorkRailwayRecMainController")
public class MeterWorkRailwayRecMainController extends BaseRESTfulController {

    @Autowired
    IMeterWorkRailwayRecMainService meterWorkRailwayRecMainService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkrailwayrecmain:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkRailwayRecMain> list = meterWorkRailwayRecMainService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkrailwayrecmain:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<MeterWorkRailwayRecMain> list = meterWorkRailwayRecMainService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkrailwayrecmain:view")
    @PostMapping(value = "/listLikePost/")
    public RESTfulResult listLikePost(@RequestBody HashMap parmas){
        Integer pageNum = parmas.get("pageNum") == null ? 1 : Integer.parseInt(parmas.get("pageNum").toString());
        Integer pageSize =parmas.get("pageSize") == null ? 20 : Integer.parseInt(parmas.get("pageSize").toString());
        PageList<MeterWorkRailwayRecMain> list = meterWorkRailwayRecMainService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkrailwayrecmain:view")
    @PostMapping(value = "/listBynoPage")
    public RESTfulResult listBynoPage(@RequestBody HashMap parmas){
        List<MeterWorkRailwayRecMain> list = meterWorkRailwayRecMainService.listBynoPage(parmas);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据MeterWorkRailwayRecMain对象创建")
    @ApiImplicitParam(name = "meterWorkRailwayRecMain", value = "详细实体meterWorkRailwayRecMain", required = true, dataType = "MeterWorkRailwayRecMain")
    //@RequiresPermissions("meterworkrailwayrecmain:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody MeterWorkRailwayRecMain model){
        RESTfulResult rm = failed();
        try {
            RESTfulResult res = meterWorkRailwayRecMainService.checkandadd(model);
            return res;
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkrailwayrecmain:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        MeterWorkRailwayRecMain meterWorkRailwayRecMain = meterWorkRailwayRecMainService.getById(id);
        return success(meterWorkRailwayRecMain);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的meterWorkRailwayRecMain信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "meterWorkRailwayRecMain", value = "详细实体meterWorkRailwayRecMain", required = true, dataType = "MeterWorkRailwayRecMain")
    })
    //@RequiresPermissions("meterworkrailwayrecmain:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkRailwayRecMain model){
        model.setId(id);
        MeterWorkRailwayRecMain meterWorkRailwayRecMain = meterWorkRailwayRecMainService.modify(model);
        return success(meterWorkRailwayRecMain);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkrailwayrecmain:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  meterWorkRailwayRecMainService.delete(ids);
    	}
      return success();
    }

    @ApiOperation(value="创建", notes="根据MeterWorkRailwayRecMain对象创建")
    @ApiImplicitParam(name = "meterWorkRailwayRecMain", value = "详细实体meterWorkRailwayRecMain", required = true, dataType = "MeterWorkRailwayRecMain")
    //@RequiresPermissions("meterworkrailwayrecmain:create")
    @PostMapping(value = "/doAddList")
    public RESTfulResult doAddList(@RequestBody newCls model){
        RESTfulResult rm = failed();
        try {
            RESTfulResult res = meterWorkRailwayRecMainService.addList(model.getMain(), model.getReceived());
            return res;
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }
}
